searchNodes=[{"doc":"Elixir state machines and statecharts Usage iex&gt; definition = %{ iex&gt; id: &quot;toggle&quot;, iex&gt; initial: :inactive, iex&gt; states: %{ iex&gt; inactive: %{ iex&gt; on: %{ iex&gt; TOGGLE: %{ iex&gt; target: :active iex&gt; } iex&gt; } iex&gt; }, iex&gt; active: %{ iex&gt; on: %{ iex&gt; TOGGLE: %{ iex&gt; target: :inactive iex&gt; } iex&gt; } iex&gt; } iex&gt; } iex&gt; } iex&gt; machine = ExState.machine(definition) # and now create state machine iex&gt; ExState.transition(machine, :TOGGLE) # and transit to new state %ExState.Machine{ context: nil, id: &quot;toggle&quot;, initial: :inactive, options: %ExState.Options{actions: nil, guards: nil}, state: %ExState.State{ context: nil, event: %ExState.Event{data: nil, type: :TOGGLE}, value: :active }, states: %{ active: %ExState.NodeType.Atomic{ on: %{ TOGGLE: %ExState.Transition{actions: [], cond: nil, target: :inactive} } }, inactive: %ExState.NodeType.Atomic{ on: %{ TOGGLE: %ExState.Transition{actions: [], cond: nil, target: :active} } } } }","ref":"ExState.html","title":"ExState","type":"module"},{"doc":"See ExState.Machine.create/2","ref":"ExState.html#machine/2","title":"ExState.machine/2","type":"function"},{"doc":"See ExState.Machine.transition/2","ref":"ExState.html#transition/2","title":"ExState.transition/2","type":"function"},{"doc":"A context helpers","ref":"ExState.Context.html","title":"ExState.Context","type":"module"},{"doc":"","ref":"ExState.Context.html#assign/1","title":"ExState.Context.assign/1","type":"function"},{"doc":"An event structure.","ref":"ExState.Event.html","title":"ExState.Event","type":"module"},{"doc":"","ref":"ExState.Event.html#create/1","title":"ExState.Event.create/1","type":"function"},{"doc":"A finite state machine definition.","ref":"ExState.Machine.html","title":"ExState.Machine","type":"module"},{"doc":"","ref":"ExState.Machine.html#create/2","title":"ExState.Machine.create/2","type":"function"},{"doc":"","ref":"ExState.Machine.html#transition/2","title":"ExState.Machine.transition/2","type":"function"},{"doc":"A state node specifies a state configuration.","ref":"ExState.NodeType.html","title":"ExState.NodeType","type":"module"},{"doc":"","ref":"ExState.NodeType.html#create/1","title":"ExState.NodeType.create/1","type":"function"},{"doc":"","ref":"ExState.NodeType.html#t:type/0","title":"ExState.NodeType.type/0","type":"type"},{"doc":"An atomic state node","ref":"ExState.NodeType.Atomic.html","title":"ExState.NodeType.Atomic","type":"module"},{"doc":"","ref":"ExState.NodeType.Atomic.html#create/1","title":"ExState.NodeType.Atomic.create/1","type":"function"},{"doc":"A compound state node","ref":"ExState.NodeType.Compound.html","title":"ExState.NodeType.Compound","type":"module"},{"doc":"","ref":"ExState.NodeType.Compound.html#create/1","title":"ExState.NodeType.Compound.create/1","type":"function"},{"doc":"A final state node","ref":"ExState.NodeType.Final.html","title":"ExState.NodeType.Final","type":"module"},{"doc":"","ref":"ExState.NodeType.Final.html#create/1","title":"ExState.NodeType.Final.create/1","type":"function"},{"doc":"A history state node","ref":"ExState.NodeType.History.html","title":"ExState.NodeType.History","type":"module"},{"doc":"","ref":"ExState.NodeType.History.html#create/1","title":"ExState.NodeType.History.create/1","type":"function"},{"doc":"A parallel state node","ref":"ExState.NodeType.Parallel.html","title":"ExState.NodeType.Parallel","type":"module"},{"doc":"","ref":"ExState.NodeType.Parallel.html#create/1","title":"ExState.NodeType.Parallel.create/1","type":"function"},{"doc":"A state machines options","ref":"ExState.Options.html","title":"ExState.Options","type":"module"},{"doc":"","ref":"ExState.Options.html#action/2","title":"ExState.Options.action/2","type":"function"},{"doc":"","ref":"ExState.Options.html#create/1","title":"ExState.Options.create/1","type":"function"},{"doc":"","ref":"ExState.Options.html#guard/2","title":"ExState.Options.guard/2","type":"function"},{"doc":"A transition request.","ref":"ExState.Request.html","title":"ExState.Request","type":"module"},{"doc":"","ref":"ExState.Request.html#create/2","title":"ExState.Request.create/2","type":"function"},{"doc":"A FSM state","ref":"ExState.State.html","title":"ExState.State","type":"module"},{"doc":"","ref":"ExState.State.html#context/1","title":"ExState.State.context/1","type":"function"},{"doc":"","ref":"ExState.State.html#create/3","title":"ExState.State.create/3","type":"function"},{"doc":"","ref":"ExState.State.html#move/1","title":"ExState.State.move/1","type":"function"},{"doc":"","ref":"ExState.State.html#value/1","title":"ExState.State.value/1","type":"function"},{"doc":"A states creator","ref":"ExState.States.html","title":"ExState.States","type":"module"},{"doc":"","ref":"ExState.States.html#create/1","title":"ExState.States.create/1","type":"function"},{"doc":"A state transition defines what the next state is.","ref":"ExState.Transition.html","title":"ExState.Transition","type":"module"},{"doc":"","ref":"ExState.Transition.html#actions/1","title":"ExState.Transition.actions/1","type":"function"},{"doc":"","ref":"ExState.Transition.html#create/1","title":"ExState.Transition.create/1","type":"function"},{"doc":"","ref":"ExState.Transition.html#guard/1","title":"ExState.Transition.guard/1","type":"function"},{"doc":"","ref":"ExState.Transition.html#target/1","title":"ExState.Transition.target/1","type":"function"},{"doc":"State transitions are defined on state nodes, in the on key.","ref":"ExState.Transitions.html","title":"ExState.Transitions","type":"module"},{"doc":"","ref":"ExState.Transitions.html#create/1","title":"ExState.Transitions.create/1","type":"function"},{"doc":"Getting Started Suppose we want to model a simple semaphore as state machine. First, install ExState: def deps do [ {:ex_state, &quot;~&gt; 2.0.1&quot;} ] end mix deps.get Then, in your project: semaphore = ExState.machine(...); We&#39;ll pass the machine configuration inside of ExState.machine(...). Since this is a hierarchical machine, we need to provide the: id - to identify the machine and set the base string for its child state node IDs initial - to specify the initial state node this machine should be in states - to define each of the child states: semaphore = ExState.machine(%{ id: &quot;semaphore&quot;, initial: :red, states: %{ red: %{}, green: %{} } }) Then, we need to add transitions to the state nodes: semaphore = ExState.machine({ id: &quot;semaphore&quot;, initial: :red, states: %{ red: %{ on: %{ switch: %{target: :green} } }, green: %{ on: %{ switch: %{target: :red} } } } }); and now make some transtion to next states: semaphore.state.value == :red semaphore = ExState.transtion(semaphore, :switch) semaphore.state.value == :green # and back semaphore = ExState.transtion(semaphore, :switch) semaphore.state.value == :red","ref":"getting_started.html","title":"Getting Started","type":"extras"},{"doc":"Events An event is what causes a state machine to transition from its current state to its next state. All state transitions in a state machine are due to these events; state cannot change unless some stimulus (the event) causes it to change.","ref":"events.html","title":"Events","type":"extras"},{"doc":"Machines A state machine is a finite set of states that can transition to each other deterministically due to events. A statechart is an extension of state machines; mainly, they can have: Hierarchical (or nested) states Orthogonal (or parallel) states History states And more, as described in Statecharts: a Visual Formalism for Complex Systems.","ref":"machines.html","title":"Machines","type":"extras"},{"doc":"States A state is an abstract representation of a system (such as an application) at a specific point in time. As an application is interacted with, events cause it to change state. A finite state machine can be in only one of a finite number of states at any given time.","ref":"states.html","title":"States","type":"extras"},{"doc":"State Nodes A state machine contains state nodes (explained below) that collectively describe the overall state a machine can be in.","ref":"statenodes.html","title":"State Nodes","type":"extras"},{"doc":"Transitions A state transition defines what the next state is, given the current state and event. State transitions are defined on state nodes, in the on property:","ref":"transitions.html","title":"Transitions","type":"extras"},{"doc":"Hierarchical State Nodes Statecharts, by definition, are hierarchical - that is to say, they: enable refinement of state can group similar transitions allow isolation encourage composability and prevent state explosion, which frequently occurs in normal finite state machines. ...","ref":"hierarchical.html","title":"Hierarchical State Nodes","type":"extras"},{"doc":"History A history state node is a special kind of state node that, when reached, tells the machine to go to the last state value of that region.","ref":"history.html","title":"History","type":"extras"},{"doc":"Parallel State Nodes A parallel state node represents multiple orthogonal child state nodes; that is, a parallel state is in all of its child states at the same time. The key word here is parallel (or orthogonal) - the states are not directly dependent on each other, and no transitions should exist between parallel state nodes. A parallel state node is specified on the machine and/or any nested compound state by setting type: &#39;parallel&#39;.","ref":"parallel.html","title":"Parallel State Nodes","type":"extras"}]